//----------------------------------------------------------------------------------------
//
// customseek.m
//
//----------------------------------------------------------------------------------------
// Use like this :
// #define CUSTOM_SEEK_VAR MyVar
// #include "customseek.m"
//
//
// What you need :  
//                       _MyVarInit(Layer seeksurface, Layer seekghost, Map seekmap); 
//                       _MyVarShutdown(); 
//



Global Layer _##CUSTOM_VOL_VAR##Surface;
Global Layer _##CUSTOM_VOL_VAR##Ghost;
Global Map _##CUSTOM_VOL_VAR##Map;
Global Int _##CUSTOM_VOL_VAR##Clicked;

Function _##CUSTOM_VOL_VAR##Init(Layer s, Layer g, Map m);
Function _##CUSTOM_VOL_VAR##Update();
Function _##CUSTOM_VOL_VAR##UpdateXY(int x, int y);
Function _##CUSTOM_VOL_VAR##Shutdown();

_##CUSTOM_VOL_VAR##Init(Layer s, Layer g, Map m) {
  _##CUSTOM_VOL_VAR##Surface = s;
  _##CUSTOM_VOL_VAR##Ghost = g;
  _##CUSTOM_VOL_VAR##Map = m;
  _##CUSTOM_VOL_VAR##Update();
}

_##CUSTOM_VOL_VAR##Surface.onLeftButtonDown(int x, int y) {
  _##CUSTOM_VOL_VAR##Clicked = 1;
  _##CUSTOM_VOL_VAR##UpdateXY(x, y);
}

_##CUSTOM_VOL_VAR##Surface.onMouseMove(int x, int y) {
  if (_##CUSTOM_VOL_VAR##Clicked) {
    _##CUSTOM_VOL_VAR##UpdateXY(x, y);
  }
}

_##CUSTOM_VOL_VAR##Surface.onLeftButtonUp(int x, int y) {
  if (!_##CUSTOM_VOL_VAR##Clicked) return;  
  _##CUSTOM_VOL_VAR##Clicked = 0;
}

_##CUSTOM_VOL_VAR##UpdateXY(int x, int y) {
  int n = _##CUSTOM_VOL_VAR##Map.getValue(x, y);
  Region r = new Region;
  r.loadFromMap(_##CUSTOM_VOL_VAR##Map, n, 1);
  r.offset(-_##CUSTOM_VOL_VAR##Ghost.getLeft(), -_##CUSTOM_VOL_VAR##Ghost.getTop());
  _##CUSTOM_VOL_VAR##Ghost.setRegion(r);
  System.setVolume(n);
  delete r;
}

_##CUSTOM_VOL_VAR##Update() {
  int l = System.getVolume();
  Region r = new Region;
  r.loadFromMap(_##CUSTOM_VOL_VAR##Map, l, 1);
  r.offset(-_##CUSTOM_VOL_VAR##Ghost.getLeft(), -_##CUSTOM_VOL_VAR##Ghost.getTop());
  _##CUSTOM_VOL_VAR##Ghost.setRegion(r);
  delete r;
}

System.onVolumeChanged(int newvol) {
  if ( _##CUSTOM_VOL_VAR##Clicked != 1) {
   _##CUSTOM_VOL_VAR##Update();
  }
}



